class Particle {

  PVector center;
  PVector velocity;
  float lifespan;
  int life;

  PShape part;
  float partSize;

  PVector gravity = new PVector(0, 0.1);

  Particle() {    
    partSize = random(10, 60);
    part = createShape();
    part.beginShape(QUAD);
    part.noStroke();
    part.texture(sprite);
    part.normal(0, 0, 1);
    part.vertex(-partSize/2, -partSize/2, 0, 0);
    part.vertex(+partSize/2, -partSize/2, sprite.width, 0);
    part.vertex(+partSize/2, +partSize/2, sprite.width, sprite.height);
    part.vertex(-partSize/2, +partSize/2, 0, sprite.height);
    part.endShape();

    center = new PVector(); 

    rebirth(width/2, height/2);
  }

  PShape getShape() {
    return part;
  }

  void rebirth(float x, float y) {
    float a = random(TWO_PI);
    float speed = random(0.5, 4);
    velocity = PVector.fromAngle(a);
    velocity.mult(speed);
    lifespan = 255;
    life = 255;
     part.resetMatrix();
    part.translate(x, y); 

    center.set(x, y, 0);
  }

  boolean isDead() {
    if (center.x > width  || center.x < 0 || 
      center.y > height || center.y < 0 || lifespan < 0) {
      return true;
    } else {
      return false;
    }
  }

  void update() {
    lifespan = lifespan - 10;
    velocity.add(gravity);
    part.setTint(color(46, random(10, 255), 255, lifespan));
    part.translate(velocity.x, velocity.y);
    center.add(velocity);
  }
}
