import ddf.minim.*;
import ddf.minim.analysis.*;
PImage birbs[];

Minim minim;
FFT fftMid, fftHigh;


AudioSample bassC;
AudioSample bassE;
AudioSample bassG;
AudioSample bassA;

AudioSample midC;
AudioSample midD;
AudioSample midE;
AudioSample midG;
AudioSample midA;
AudioSample midC2;

AudioSample highC;
AudioSample highD;
AudioSample highE;
AudioSample highG;
AudioSample highA;
AudioSample highC2;

AudioSample bass[] = {bassC, bassE, bassG, bassA};
AudioSample mid[] = {midC, midD, midE, midG, midA, midC2};
AudioSample high[] = {highC, highD, highE, highG, highA, highC2};

int buffer = 512;
int n; //array number for mid
float fftMidScale;
float fftHighScale;
float dx = 200;

boolean lines;
float goUp = height; //sunset lines

int[] birbPos = new int[3];//= height/5+50;  GAIN CONTROLLERS
float turn = 0;

int[] starPos; //star y position
int starGlow = 50;

color ocean = color(1, 49, 94);
color sun = color(255, 196, 116);
color sky = color(122, 36, 119);
color highlight = color(255, 221, 188);
color sunset = color(216, 66, 66);

float mouseSize = 50;

ParticleSystem ps;
PImage sprite;

void setup() {
  size(displayWidth, displayHeight, P2D);
  minim = new Minim(this);
  frameRate(30);
  colorMode(HSB);
  noCursor();

  bass[0] = minim.loadSample("bassC.mp3", buffer);
  bass[1] = minim.loadSample("bassE.mp3", buffer);
  bass[2] = minim.loadSample("bassG.mp3", buffer);
  bass[3] = minim.loadSample("bassA.mp3", buffer);

  mid[0] = minim.loadSample("midC.mp3", buffer);
  mid[1] = minim.loadSample("midD.mp3", buffer);
  mid[2] = minim.loadSample("midE.mp3", buffer);
  mid[3] = minim.loadSample("midG.mp3", buffer);
  mid[4] = minim.loadSample("midA.mp3", buffer);
  mid[5] = minim.loadSample("midC2.mp3", buffer);

  high[0] = minim.loadSample("highC.mp3", buffer);
  high[1] = minim.loadSample("highD.mp3", buffer);
  high[2] = minim.loadSample("highE.mp3", buffer);
  high[3] = minim.loadSample("highG.mp3", buffer);
  high[4] = minim.loadSample("highA.mp3", buffer);
  high[5] = minim.loadSample("highC2.mp3", buffer);

  fftMid = new FFT(mid[0].bufferSize(), mid[0].sampleRate());
  fftMidScale = fftMid.specSize()/16;
  fftHigh = new FFT(high[0].bufferSize(), high[0].sampleRate());
  fftHighScale = fftHigh.specSize()/8;

  birbs = new PImage[3];

  sprite = loadImage("sprite.png");
  ps = new ParticleSystem(10);
  hint(DISABLE_DEPTH_MASK);


  //birb = loadImage("birb.png");
  for (int i=0; i<birbs.length; i++) {
    birbs[i] = loadImage("birb.png");
    birbPos[i] = height/5+50;
  }

  starPos = new int[high.length];
  for (int i = 0; i < high.length; i++) {
    starPos[i] =  int(random(10, height*0.4));
  }
}

void draw() {
  background(sky);

  midSun();
  bassWaves();
  highWaves();
  birbAnimation();
  ps.update();
  ps.display();
  glowCursor();

  //GAIN CONTROLLERS
  float gain;
  for (int i = 0; i < bass.length; i++) {
    gain = map(birbPos[0], 0, height, 6, -48);
    bass[i].setGain(gain);
  }
  for (int i = 0; i < mid.length; i++) {
    gain = map(birbPos[1], 0, height, 6, -48);
    mid[i].setGain(gain);
  }
  for (int i = 0; i < high.length; i++) {
    gain = map(birbPos[2], 0, height, 6, -48);
    high[i].setGain(gain);
  }

  fill(highlight);
  textAlign(CENTER);
  textSize(20);
  text("Click on objects to interact. Slide the birds up and down to adjust the gain. Press SPACE to stop.", width/2, height*0.9);
}

void mousePressed() {
  //println(mouseY);
  for (int i=1; i<5; i++) { //bass tones
    int y = height-(i*70);
    if (mouseY>y-20 && mouseY < y+20) {
      bass[i-1].trigger();
    }
  }


  for (int i = 1; i<7; i++) {  //high tones
    int x = i*(width/7);
    if (mouseY>starPos[i-1]-10 && mouseY < starPos[i-1]+10 && mouseX>x-10 && mouseX<x+10) { 
      //if(mouseY==y){
      high[i-1].trigger();
    }
  }
}

void mouseDragged() {
  //FOR MID
  dx = int(dist(mouseX, mouseY, width/2, height-(height/3)));
  dx = constrain(dx, 175, 200);

  //FOR BIRBS
  if (mouseY<height/2) {
    if (mouseX>(width/4) && mouseX<(width/4)+birbs[0].width)
      birbPos[0] = constrain(mouseY, 0, height/2);
    if (mouseX>(width/2) && mouseX<(width/2)+birbs[1].width)
      birbPos[1] = constrain(mouseY, 0, height/2);
    if (mouseX>(width-width/4) && mouseX<(width-width/4)+birbs[2].width)
      birbPos[2] = constrain(mouseY, 0, height/2);
  }
}

void mouseReleased() {
  //FOR MID
  for (int i=0; i < 6; i++) { //mid tones
    int r = 200/6;
    if (dist(mouseX, mouseY, width/2, height-(height/3))>r*(i) && dist(mouseX, mouseY, width/2, height-(height/3))< r*(i+1)) {
      mid[i].trigger();
      n = i;
    }
  }

  //RELEASE PARTICLES
  ps.setEmitter(mouseX, mouseY);
}

void midSun() {
  colorMode(RGB);
  fill(sun);
  stroke(sun);

  fftMid.forward(mid[n].mix);

  push();  
  translate(width/2, height-(height/3));
  //fill(247, 226, 136);
  beginShape();
  rotate(HALF_PI);
  for (int i = 0; i < fftMidScale; i++) {
    float amp = fftMid.getBand(i);
    if (amp != 0) lines = true;
    else lines = false;

    //FOR CIRCLE
    float angle = map(i, 0, fftMidScale, 0, 360);
    float r = map(amp, 0, 64, dx, 250);
    float x = r*cos(radians(angle));
    float y = r*sin(radians(angle));
    curveVertex(x, y);
  }
  endShape();
  pop();

  if (!mousePressed && dx < 196) {
    dx+=5;
  }
  if (dx < 201) 
    if (!mousePressed && dx < 200) dx++;

  if (lines == true) drawLines();



  //hide sun
  fill(highlight);
  rect(0, height-280, width, height);


  push();
  fill(sun, random(50, 53));
  noStroke();
  translate(width/2, height-(height/3));
  circle(0, 0, dx*5);
  pop();
}

void drawLines() {
  pushStyle();
  stroke(sky);

  strokeWeight(10);
  for (int i = height+1; i > 0; i-=100) {
    line(0, goUp-i, width, goUp-i);
    if (goUp < height-100) goUp = height;
    goUp-=0.25;
  }
  popStyle();
}

void bassWaves() {
  noStroke();

  strokeWeight(2);
  for (int i=0; i<bass[0].bufferSize()-1; i++) {
    float x1 = map(i, 0, bass[0].bufferSize(), 0, width);
    float x2 = map(i+1, 0, bass[0].bufferSize(), 0, width);

    for (int j = 0; j<bass.length; j++) {

      fill(122, 36, 255-j*35);
      int y = j+1; 
      y = y*70;
      y = height-y;
      beginShape(); //WAVE SHAPES
      vertex(0, y+70); //bottom left
      vertex(x1, y-bass[j].mix.get(i)*100); //top left
      vertex(x2, y-bass[j].mix.get(i+1)*100); //top right
      vertex(width, y+70); //bottom right
      endShape(CLOSE);
    }
  }
}

void highWaves() {
  colorMode(HSB);
  for (int i=0; i<fftHighScale; i++) {
    for (int j=1; j<high.length+1; j++) {    
      fftHigh.forward(high[j-1].mix);
      
      pushMatrix();
      translate((width/7)*j, starPos[j-1]);
      
      pushStyle();
      fill(map(63, 0, 359, 0, 255)*j, map(16, 0, 100, 0, 255), map(100, 0, 100, 0, 255), random(1, 3));
      noStroke();
      circle(0, 0, starGlow);
      blendMode(ADD);
      popStyle();

      stroke(map(63, 0, 359, 0, 255)*j, map(16, 0, 100, 0, 255), map(100, 0, 100, 0, 255));
      float amp = fftHigh.getBand(i);
      float angle = map(i, 0, fftHighScale, 0, 360);
      float r = map(amp, 0, 1, 5, 15);
      float x = r*cos(radians(angle));
      float y = r*sin(radians(angle));
      line(0, 0, x, y);
      popMatrix();
    }
  }
}

void birbAnimation() {
  //birds animation
  int x = width/4;
  for (int i=1; i<4; i++) {
    push();
    translate(i*x, birbPos[i-1]);
    float rotation = map(sin(radians(millis()/30*i)), -1, 1, -0.5, 0.5);
    rotate(rotation);
    image(birbs[i-1], 0, 0, birbs[i-1].height*0.7, birbs[i-1].width*0.7);
    pop();
  }
}

void glowCursor() {
  noStroke();
  ellipseMode(CENTER);
  for (int i=0; i<mouseSize; i++) {
    fill(176, 50, 255, 4);
    circle(mouseX, mouseY, i);
  }
  if (mousePressed && mouseSize>30)
    mouseSize--;
  if (!mousePressed && mouseSize < 44)
    mouseSize=mouseSize+7;
}

void keyPressed() {
  if (key == ' ')
    minim.stop();
}
